function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
import { PersistError } from "./errors.mjs";
import isDeepEqual from "./is-deep-equal.mjs";
export var saveAll = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator(function* (state, oldState, _ref) {
    var prefix = _ref.prefix,
      driver = _ref.driver,
      serialize = _ref.serialize;
    if (!isDeepEqual(state, oldState)) {
      return driver.setItem(prefix + "rootState", serialize(state, 'rootState'));
    }
  });
  return function saveAll(_x, _x2, _x3) {
    return _ref2.apply(this, arguments);
  };
}();
export var saveAllKeyed = function saveAllKeyed(state, oldState, _ref3) {
  var prefix = _ref3.prefix,
    driver = _ref3.driver,
    serialize = _ref3.serialize;
  return Promise.all(Object.keys(state).map(function (key) {
    if (isDeepEqual(state[key], oldState[key])) {
      return Promise.resolve();
    }
    return driver.setItem("" + prefix + key, serialize(state[key], key));
  }));
};
export var persist = /*#__PURE__*/function () {
  var _ref5 = _asyncToGenerator(function* (state, oldState, _ref4) {
    if (state === void 0) {
      state = {};
    }
    if (oldState === void 0) {
      oldState = {};
    }
    var prefix = _ref4.prefix,
      driver = _ref4.driver,
      persistWholeStore = _ref4.persistWholeStore,
      serialize = _ref4.serialize,
      errorHandler = _ref4.errorHandler;
    try {
      var save = persistWholeStore ? saveAll : saveAllKeyed;
      yield save(state, oldState, {
        prefix: prefix,
        driver: driver,
        serialize: serialize
      });
    } catch (err) {
      errorHandler(new PersistError(err));
    }
  });
  return function persist(_x4, _x5, _x6) {
    return _ref5.apply(this, arguments);
  };
}();
//# sourceMappingURL=persist.mjs.map